﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using RctcOS.Pololu;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace RctcOS.MaestroTestUi
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public Maestro _maestro { get; set; }

        public MainPage()
        {
            this.InitializeComponent();
        }

        private async void Page_Loaded(object sender, RoutedEventArgs e)
        {
            _maestro = await Maestro.CreateMaestroController(Maestro.MaestroModel.MiniMaestro12Channel);
            for( int channel = 0; channel < _maestro.Channels; channel ++ )
            {
                ucServo channelControl = new ucServo(channel);
                channelControl.PositionChanged = ServoChannelChanged;
                stkServoControls.Children.Add(channelControl);
            }
        }

        public async void ServoChannelChanged(object sender, RoutedEventArgs e)
        {
            ucServoChangedRoutedEvent servoEvent = e as ucServoChangedRoutedEvent;
            if ( _maestro != null && servoEvent != null )
            {
                await _maestro.SetTarget(servoEvent.Channel, servoEvent.Position);
            }
        }
    }
}
