﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

namespace RctcOS.MaestroTestUi
{
    public sealed partial class ucServo : UserControl
    {
        public delegate void PositionChangedEventHandler(object sender, ucServoChangedRoutedEvent e);
        public PositionChangedEventHandler PositionChanged;

        private byte _channel;

        public ucServo(int channel)
        {
            _channel = (byte)channel;
            InitializeComponent();
            tbChannel.Text = "Channel " + channel;
        }

        private void sldPosition_ValueChanged(object sender, RangeBaseValueChangedEventArgs e)
        {
            if( PositionChanged != null )
            {
                ucServoChangedRoutedEvent rea = new ucServoChangedRoutedEvent
                {
                    Channel = _channel,
                    Position = (ushort)e.NewValue
                };

                PositionChanged(this, rea);
            }
        }
    }
}
