﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RctcOS.Pololu
{
    public partial class Maestro
    {
        private const ushort PololuUsbVid = 0x1ffb;
        private const ushort MicroMaestro6ChannelPid = 0x0089;
        private const ushort MiniMaestro12Channel = 0x008a;
        private const ushort MiniMaestro18Channel = 0x008b;
        private const ushort MiniMaestro24Channel = 0x008c;

        public enum MaestroModel
        {
            MicroMaestro6Channel    = 1,
            MiniMaestro12Channel    = 2,
            MiniMaestro18Channel    = 3,
            MiniMaestro24Channel    = 4
        };

        public enum Command : byte
        {
            SetTarget   = 0x84,
            SetSpeed    = 0x87,
            SetAcceleration = 0x89,
            GetPosition = 0x90,
            GetMovingState = 0x93,
            GetErrors = 0xa1
        }

        /// <summary>
        /// The correspondence between errors and bits in the two-byte error register.
        /// For more details about what the errors mean, see the user's guide. 
        /// </summary>
        public enum uscError : byte
        {
            ERROR_SERIAL_SIGNAL = 0,
            ERROR_SERIAL_OVERRUN = 1,
            ERROR_SERIAL_BUFFER_FULL = 2,
            ERROR_SERIAL_CRC = 3,
            ERROR_SERIAL_PROTOCOL = 4,
            ERROR_SERIAL_TIMEOUT = 5,
            ERROR_SCRIPT_STACK = 6,
            ERROR_SCRIPT_CALL_STACK = 7,
            ERROR_SCRIPT_PROGRAM_COUNTER = 8,
        };
    }
}
